/// <reference types="node" />
import { type MessageOrCCLogEntry, TransmitStatus } from "@zwave-js/core";
import type { ZWaveHost } from "@zwave-js/host";
import type { INodeQuery, SuccessIndicator } from "@zwave-js/serial";
import { Message, type MessageBaseOptions, type MessageDeserializationOptions, type MessageOptions } from "@zwave-js/serial";
export declare class DeleteSUCReturnRouteRequestBase extends Message {
    constructor(host: ZWaveHost, options: MessageOptions);
}
export interface DeleteSUCReturnRouteRequestOptions extends MessageBaseOptions {
    nodeId: number;
}
export declare class DeleteSUCReturnRouteRequest extends DeleteSUCReturnRouteRequestBase implements INodeQuery {
    constructor(host: ZWaveHost, options: MessageDeserializationOptions | DeleteSUCReturnRouteRequestOptions);
    nodeId: number;
    serialize(): Buffer;
}
interface DeleteSUCReturnRouteResponseOptions extends MessageBaseOptions {
    wasExecuted: boolean;
}
export declare class DeleteSUCReturnRouteResponse extends Message implements SuccessIndicator {
    constructor(host: ZWaveHost, options: MessageDeserializationOptions | DeleteSUCReturnRouteResponseOptions);
    isOK(): boolean;
    readonly wasExecuted: boolean;
    serialize(): Buffer;
    toLogEntry(): MessageOrCCLogEntry;
}
interface DeleteSUCReturnRouteRequestTransmitReportOptions extends MessageBaseOptions {
    transmitStatus: TransmitStatus;
    callbackId: number;
}
export declare class DeleteSUCReturnRouteRequestTransmitReport extends DeleteSUCReturnRouteRequestBase implements SuccessIndicator {
    constructor(host: ZWaveHost, options: MessageDeserializationOptions | DeleteSUCReturnRouteRequestTransmitReportOptions);
    isOK(): boolean;
    readonly transmitStatus: TransmitStatus;
    serialize(): Buffer;
    toLogEntry(): MessageOrCCLogEntry;
}
export {};
//# sourceMappingURL=DeleteSUCReturnRouteMessages.d.ts.map